/*=================================================================================
	uartctrl.c
-----------------------------------------------------------------------------------
	dsPICʐM䂷vO
	Ep\R瑗MLCDɕ\
		R}h@Txxxx... (x16܂)	j@THello,dsPIC!
	Ep\R瑗M2iLED_
		R}h@Lbbbbbbbb(b8rbg܂)	j@L01010110
	EXCb`͏Ԃp\R擾
		R}h@I

	NbN\[X	Fosc = 7.37[MHz] :dsPIC̓NbNgp
	VXeNbNFsy  = 7.37 * 8 = 58.96[MHz] :PLLx8gp
	߃NbN	Fcy  = 58.96 / 4 = 14.74[MHz]
=================================================================================*/
#include <p30f5011.h>	//TRISB̓@\WX^gp邽߂ɌĂяo
#include "lcd.h"		//wait֐сALCD֘Å֐gp邽߂ɌĂяo
#include "uart.h"		//uartini֐gp邽߂ɌĂяo

//Configuration bits (dsPIC̊{ݒ)----------------------------------------------
_FOSC(CSW_FSCM_OFF & FRC_PLL8);		//RCiNbNj8{, NbNj^[OFF
_FWDT(WDT_OFF);						//EHb`hbO^C}[OFF
_FBORPOR(PBOR_OFF & MCLR_EN);		//uEAEgZbgOFF, }X^[NAL
_FGS(CODE_PROT_OFF);				//R[hیOFF
//----------------------------------------------------------------------------------------
#define CR	0x0D		//sLbW^[
#define LF	0x0A		//sCtB[h

/* ֐vg^Cv */
void text(void);		//LCDւ̃eLXg\
void led(void);			//LED_
void sw(void);			//XCb`͏Ԏ擾

int i=0,j=0,k=0,l=0,m=0;//fořJԂ񐔁AMf[^̊i[
char charbuffer[20];	//Mf[^obt@
char lcddata[17];		//LCDf[^obt@
int flg=0;				//ʐMtO
int cnt=0;				//͕iR}hAs܂܂j

int main(void)
{
	TRISB = 0xffc0;		//RB5-RB0:o,RB8:
	TRISD = 0xff00;		//RD7-RD0:o,RD11-RD8:

	SR = ((SR & 0xff1f) | 0x0020);	//MPU荞ݗDx1ɐݒ
	INTCON1 = 0x0000;				//d荞ݗL
	INTCON2 = 0x0000;				//IVTgp

	InitLCD();			//LCD̏
	uartini();			//UART̏

	PrintLCD("UART Control");	//LCDbZ[W

	while(1){
		if(flg==1){		//ʐM`FbN
			flg = 0;	//ʐMtONA
			i = 0;		//Mf[^̊i[ɖ߂

			if(charbuffer[0]=='@'){		//`FbN
				switch(charbuffer[1]){	//R}hɏ
					case 'T':	text();	//LCDւ̃eLXg\
								break;
					case 'L':	led();	//LED_
								break;
					case 'I':	sw();	//XCb`͏Ԏ擾
								break;
					default:	break;
				}

				for(j=0;j<20;j++) charbuffer[j] = 0;	//Mf[^obt@NA
			}
		}
	}
	return 0;
}

/* UARTM荞ݏ */
void __attribute__((interrupt)) _U2RXInterrupt(void)
{
	IFS1 = IFS1 & 0xfeff;		//M݃tONA
	charbuffer[i] = (char)U2RXREG;	//MWX^̓ei[
	if(charbuffer[i-1]==CR && charbuffer[i]==LF){	//nCp[^[~iCR+LF
		cnt = i-3;		//͕
		flg = 1;		//ʐMtO
	}
	i++;				//Mf[^̊i[炷
}

/* LCDւ̃eLXg\ */
void text(void)
{
	for(k=0;k<17;k++) lcddata[k] = 0x00;	//LCDf[^obt@̃NA
	ClearLCD();								//LCDNA
	for(k=0;k<cnt;k++) lcddata[k] = charbuffer[k+2];	//Mf[^LCDf[^obt@Ɋi[
	PrintLCD(lcddata);						//LCDɃeLXg\
}

/* LED_ */
void led(void)
{
	unsigned int leddata=0;	//LEDɏo͂f[^pϐ
	for(l=0;l<cnt;l++){
		leddata <<= 1;						//1rbgVtg
		leddata += (charbuffer[l+2]-'0');	//𐔎ɕϊALEDf[^ŉʃrbgɉZ
	}
	PORTD = leddata;	//LEDf[^o
}

/* XCb`͏Ԏ擾 */
void sw(void)
{
	unsigned int inputdata;	//XCb`̓f[^pϐ

	inputdata = PORTD;	//XCb`̓f[^擾
	for(m=0;m<4;m++){	//RD11RD8̏ɏ
		if(inputdata & 0x0800)	U2TXREG = '1';	//RD11`FbNđM
		else					U2TXREG = '0';
		while(!(U2STA & 0x0100));			//MWX^ɂȂ܂ňꎞ~
		inputdata <<= 1;	//XCb`̓f[^1rbgVtg
	}
	U2TXREG = CR;						//CR𑗐M
	while(!(U2STA & 0x0100));			//MWX^ɂȂ܂ňꎞ~
	U2TXREG = LF;						//LF𑗐M
	while(!(U2STA & 0x0100));			//MWX^ɂȂ܂ňꎞ~
}
